--Logger database V 1.0
------------------------------------------

CREATE TABLE Log (
  ID                text PRIMARY KEY NOT NULL,
  fk_BaseLog        text DEFAULT NULL,
  InsertDate        datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  Title             text NOT NULL,
  Message           text NOT NULL,
  Source            text,
  StackTrace        text,
  Type              integer NOT NULL DEFAULT 1,
  ExceptionMessage  text,
  Deepness          integer NOT NULL DEFAULT 0
);

CREATE TABLE Query (
  ID     integer PRIMARY KEY AUTOINCREMENT NOT NULL,
  Name   text UNIQUE,
  Query  text
);

-- Data for table Query
INSERT INTO Query (ID, Name, Query) VALUES (1, 'INSERT_LogEntry', 'INSERT INTO Log (ID,Type, Title, Message, fk_BaseLog)VALUES (@ID, @Type, @Title, @Message, @fk_BaseLog);');
INSERT INTO Query (ID, Name, Query) VALUES (2, 'INSERT_ErrorEntry', 'INSERT INTO Log(    ID,    Type,    Title,    Message,    Source,    StackTrace,    fk_BaseLog,    ExceptionMessage,    Deepness)VALUES (    @ID,     @Type,     @Title,     @Message,     @Source,     @StackTrace,     @fk_BaseLog,     @ExceptionMessage,    @Deepness);');
INSERT INTO Query (ID, Name, Query) VALUES (3, 'SELECT_LogSorted', 'SELECT *FROM LogWHERE Log.ID = Log.fk_BaseLogORDER BY Insertdate, log.fk_BaseLog, log.Deepness ASC ');
INSERT INTO Query (ID, Name, Query) VALUES (4, 'SELECT_LogOnID', 'SELECT *FROM Log WHERE Log.ID = @IDOR Log.fk_BaseLog = @IDORDER BY Insertdate, log.fk_BaseLog, log.Deepness ASC;');
INSERT INTO Query (ID, Name, Query) VALUES (5, 'SELECT_Statistics', 'SELECT MAX(InsertDate) AS ''MaxDate''  , MIN(InsertDate) AS ''MinDate''  , (SELECT COUNT(*) FROM Log WHERE deepness = 0) AS ''Count''FROM Log;');
INSERT INTO Query (ID, Name, Query) VALUES (6, 'SELECT_LogsByType', 'SELECT *FROM LogWHERE Type in( @Type)AND Deepness = 0;');
INSERT INTO Query (ID, Name, Query) VALUES (7, 'SELECT_LogsBetweenDate', 'SELECT *FROM LogWHERE Log.InsertDate > Date(''@LowerThreshold'')AND   Log.InsertDate < Date(''@UpperThreshold'')AND Deepness = 0;');
INSERT INTO Query (ID, Name, Query) VALUES (8, 'SELECT_LogsOnTitleContains', 'SELECT *FROM LogWHERE Log.Title LIKE ''%@Title%''AND Deepness = 0;');
INSERT INTO Query (ID, Name, Query) VALUES (9, 'SELECT_LogsOnMessageContains', 'SELECT *FROM LogWHERE Log.Message LIKE ''%@Message%''AND Deepness = 0;');
INSERT INTO Query (ID, Name, Query) VALUES (10, 'SELECT_LogsOnExceptionMessageContains', 'SELECT *FROM LogWHERE Log.ExceptionMessage LIKE ''%@ExceptionMessage%''AND Deepness = 0;');
INSERT INTO Query (ID, Name, Query) VALUES (11, 'SELECT_DistinctTitle', 'SELECT distinct TitleFROM Log');
INSERT INTO Query (ID, Name, Query) VALUES (12, 'SELECT_Dependency', 'SELECT *FROM Log WHERE Log.fk_BaseLog = @IDAND Log.fk_BaseLog <> Log.IDORDER BY Insertdate, log.fk_BaseLog, log.Deepness ASC;');

